package com.qtzl.sample.manager.handler;

import cn.com.taiji.common.manager.net.http.ServiceHandleException;
import com.alibaba.fastjson.JSONObject;
import com.qtzl.sample.dao.entity.TempLi;
import com.qtzl.sample.dao.repo.jpa.TempLiRepo;
import com.qtzl.sample.manager.model.protocol.AbstractSampleRequest;
import com.qtzl.sample.manager.model.protocol.AbstractSampleResponse;
import com.qtzl.sample.manager.model.protocol.SampleCmd;
import com.txffp.api.core.manager.comm.AbstractCmdManager;
import com.txffp.api.core.manager.comm.annotation.ApiHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.List;

@Service
@ApiHandler
public class SampleServiceHandler extends AbstractCmdManager<AbstractSampleRequest> {

    @Autowired
    private TempLiRepo tempLiRepo;

    public SampleServiceHandler() {
        super(SampleCmd.SAMPLE, AbstractSampleRequest.class);
    }

    @Override
    public String handleInternal(String filename, AbstractSampleRequest abstractSampleRequest) throws ServiceHandleException {
        List<TempLi> lis = tempLiRepo.findAll();
        AbstractSampleResponse res = new AbstractSampleResponse();
        abstractSampleRequest.toJson();
        res.setList(lis);
        return res.toJson();
    }

    public static void main(String[] args) {
        AbstractSampleRequest abstractSampleRequest = new AbstractSampleRequest();
        abstractSampleRequest.setA(LocalDateTime.now());
    }
}
