/*
 * Date: 2015年4月10日
 * author: Peream  (peream@gmail.com)
 *
 */
package com.qtzl.sample.manager.model.protocol;

import cn.com.taiji.common.manager.net.http.ServiceHandleException;




public enum UcServiceError
{
	NOT_FOUND_DATA(800, "未查询到数据"){},
	BUSINESS_VALIDATE_ERR(704, "业务校验失败") {},
	CMD_NOT_EXIST(700, "命令不存在") {},
	FILE_RECEIVE_ERR(701, "接收失败") {},
	FILE_PARSE_ERR(702, "文件解析失败") {},
	FORMAT_VALIDATE_ERR(703, "文件格式校验失败") {},
	PERSIST_ERR(705, "数据入库失败") {},
	REPEAT(706, "数据重复") {},
	//业务公共

	// 积分
	SCORE_NOT_EXIST(850, "此积分账户不存在"){},
	BALANCE_INSUFFICIENT(850, "积分余额不足"){},
	SCORE__CONSUMPTION(850, "积分数据已被非法篡改"){},

	;
	private final int statusCode;
	private final String errorMsg;

	private UcServiceError(int statusCode, String errorMsg)
	{
		this.statusCode = statusCode;
		this.errorMsg = errorMsg;
	}

	public ServiceHandleException toHandleException(Object append)
	{
		return new ServiceHandleException(append != null ? append + "" : errorMsg, statusCode);
	}

	public int getCode()
	{
		return statusCode;
	}

	public String getMsg()
	{
		return errorMsg;
	}

}
