package com.qtzl.sample.manager.model.protocol;

import com.txffp.api.core.manager.comm.ServiceSys;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.regex.Pattern;

public enum UcServiceType implements ServiceSys
{
	SAMPLE("示例", "^SAMPLE_\\S+_\\S+\\.(json|xml)$") {},

	;
	private static Logger logger = LoggerFactory.getLogger(UcServiceType.class);
	private final String value;
	private final Pattern reqNamePattern;

	private UcServiceType(String value, String reqNamePattern)
	{
		this.value = value;
		this.reqNamePattern = Pattern.compile(reqNamePattern);
	}

	public String getValue()
	{
		return value;
	}

	public Pattern getReqNamePattern()
	{
		return reqNamePattern;
	}

	public static UcServiceType fromName(String name)
	{
		try
		{
			return UcServiceType.valueOf(name);
		}
		catch (Exception e)
		{
			logger.error(e.getMessage());
			return null;
		}
	}


	@Override
	public String systemId() {
		return "SAMPLE";
	}
	@Override
	public String systemName() {
		return "示例系统";
	}

}
