package com.qtzl.sample.manager.tools;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import cn.com.taiji.common.pub.StringTools;

public class StringUtil {
	public static Random random=new Random();

	public static List<String> stringToList(String str) {
		List<String> list = null;
		if(str!=null && !"".equals(str)) {
			list = new ArrayList<>();
			str = str.trim();
			str = str.substring(1, str.length()-1);
			String[] split = str.split(",");
			for(int i = 0; i<split.length; i++) {
				list.add(split[i]);
			}
		}
		return list;
	}
	public static Pattern INTEGER_PATTERN = Pattern.compile("^[-\\+]?[\\d]*$");  

	/**
	 * @Description: 判断字符串是否为空
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年7月17日 下午4:34:23 
	 * @param str
	 * @return
	 */
	public static boolean isBlankOrEmpty(String str) {
		if(str==null||str.trim().equals("")) {
			return true;
		}
		return false;
		
	}
	  /**
     * @Description: 判断字符串的编码格式
     * @author Li Bangming;
     * @date 2018年4月17日 下午3:25:58
     * @param str
     * @return
     */
    public static String getEncoding(String str) {        
        String encode = "GB2312";        
       try {        
           if (str.equals(new String(str.getBytes(encode), encode))) {      //判断是不是GB2312  
                String s = encode;        
               return s;      //是的话，返回“GB2312“，以下代码同理  
            }        
        } catch (Exception exception) {        
        }        
        encode = "ISO-8859-1";        
       try {        
           if (str.equals(new String(str.getBytes(encode), encode))) {      //判断是不是ISO-8859-1  
                String s1 = encode;        
               return s1;        
            }        
        } catch (Exception exception1) {        
        }        
        encode = "UTF-8";        
       try {        
           if (str.equals(new String(str.getBytes(encode), encode))) {   //判断是不是UTF-8  
                String s2 = encode;        
               return s2;        
            }        
        } catch (Exception exception2) {        
        }        
        encode = "GBK";        
       try {        
           if (str.equals(new String(str.getBytes(encode), encode))) {      //判断是不是GBK  
                String s3 = encode;        
               return s3;        
            }        
        } catch (Exception exception3) {        
        }        
       return "";        //如果都不是，说明输入的内容不属于常见的编码格式。  
    }
    /**
     * @Description: 设置UTF-8
     * @author Li Bangming;
     * @date 2018年4月17日 下午3:29:01
     * @param para
     * @return
     */
    public static String setCharset(String para,String charset) {
    	try {
    		if(getEncoding(para).equals(charset)){
        		return para;
        	}else if(getEncoding(para).equals("GB2312")){
        		para=new String(para.getBytes("GB2312"),charset);
        		return para;
        	}else if(getEncoding(para).equals("ISO-8859-1")){
        		para=new String(para.getBytes("ISO-8859-1"),charset);
        		return para;
        	}else if(getEncoding(para).equals("GBK")){
        		para=new String(para.getBytes("GBK"),charset);
        		return para;
        	}
		} catch (Exception e) {
			
		}
		return para;       
    }

	/**
	 * @Description: 判断字符串是否整型对象
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年8月14日 下午1:23:38 
	 * @param str
	 * @return 是整数返回true,否则返回false
	 */
	public static boolean isInteger(String str) {
		if(str==null){
			return true;
		}
		return INTEGER_PATTERN.matcher(str).matches();
	}
	
	/**
	 * @Description: 判断字符串是否是数字
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年8月14日 下午1:25:18 
	 * @param str
	 * @return
	 */
	public static boolean isNumeric(String str){
		if(StringUtil.isBlankOrEmpty(str)){
			 return false;
		}
	    for (int i = str.length();--i>=0;){  
	        if (!Character.isDigit(str.charAt(i))){
	            return false;
	        }
	    }
	    return true;
	}
	
    /**
     * @Description: 半角转全角
     * @author: Li Bangming;qq:1715592561     
     * @date: 2019年10月8日 下午12:51:23 
     * @param str
     * @return
     */
    public static String toSbc(String str) {
        char c[] = str.toCharArray();
        for (int i = 0; i < c.length; i++) {
            if (c[i] == ' ') {
                c[i] = '\u3000';
            } else if (c[i] < '\177') {
                c[i] = (char) (c[i] + 65248);

            }
        }
        return new String(c);
    }

    /**
     * @Description: 全角转半角
     * @author: Li Bangming;qq:1715592561     
     * @date: 2019年10月8日 下午12:51:04 
     * @param str
     * @return
     */
    public static String toDbc(String str) {
        char c[] = str.toCharArray();
        for (int i = 0; i < c.length; i++) {
            if (c[i] == '\u3000') {
                c[i] = ' ';
            } else if (c[i] > '\uFF00' && c[i] < '\uFF5F') {
                c[i] = (char) (c[i] - 65248);

            }
        }
        String returnString = new String(c);
        return returnString;
    }
	
	/**
	 * 空格判断
	 * @param str
	 * @return	true  就是没有空格  false   就是有空格
	 * @author T.rxiang
	 *
	 * 2019年6月27日
	 */
	public static boolean emptyNot(String str){
		
		if (StringTools.hasText(str)) {
			return true;
		}
		
		
		String aaString = str.replaceAll("\\s*", "");
		
		boolean aa = str.length() == aaString.length();
		
		return aa;
	}
	
	/**
	 * 特殊字符判断
	 * @param str
	 * @return	true 存在特殊字符   false不存在特殊字符
	 * @author T.rxiang
	 *
	 * 2019年6月27日
	 */
	public static boolean specialJudge(String str){
		String regEx="[`~!@#$%^&*()+=|{}':;',\\[\\].<>/?~！@#￥%……&*（）——+|{}【】‘；：”“’。，、？-]";
		Pattern p=Pattern.compile(regEx);
		Matcher m=p.matcher(str);
		System.out.println(m.find());
		
		return m.find();
	}
	
	/**
	 * 特殊字符处理
	 * @param str
	 * @return
	 * @author T.rxiang
	 *
	 * 2019年8月28日
	 */
	public static String specialHandle(String str){
		
		if (StringTools.hasText(str)) {
			return str;
		}
		
		// 特殊字符
    	String regex="[`~!@#$%^&*()+=|{}':;',\\[\\].<>/?~！@#￥%……&*（）——+|{}【】‘；：”“’。，、？-]";
    	
    	// 全角
//    	String regex_1 = "^[\\x00-\\xff]";
    	
    	// 空格
    	String regex2 = "\\s*";
    	
    	// 去掉特殊字符
    	str = str.replaceAll(regex, "");

    	// 去掉全角
//    	str = str.replaceAll(regex_1, ""); 
    	
    	// 去掉所有空格
    	str = str.replaceAll(regex2, "");
		
    	
    	//将全角替换为半角
    	str=StringUtil.toDbc(str);
    	
		return str;
	}
	
	/**
	 * @Description: 去掉空白部分，包括换行符，制表符，空格等
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年10月9日 下午1:40:31 
	 * @return
	 */
	public static String replaceBlank(String str){
		String dest = "";
	    if (str != null) {
	        dest = str.replaceAll("[\\s*|\t|\r|\n]","");
	    }
	    return dest;
	}
	/**
	 * @Description:去掉英文引号
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年10月9日 下午1:40:31 
	 * @return
	 */
	public static String replaceEnglishQuote(String str){
		String dest = "";
	    if (str != null) {
	        dest = str.replaceAll("'","");
	    }
	    return dest;
	}
	/**
	 * @Description: 获取map中参数为空的key
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年7月17日 下午4:34:23 
	 * @param str
	 * @return
	 */
	public static String getBlankOrEmptyKeys(Map<String,Object> paramMap,String ...keys) {
		
		String blankOrEmptyKeys="";
		for(String key:keys){
			Object obj=null;
			if(paramMap!=null){
				obj=paramMap.get(key);
			}
			if(obj==null||isBlankOrEmpty(String.valueOf(obj))){
				if(!isBlankOrEmpty(blankOrEmptyKeys)){
					blankOrEmptyKeys+=",";
				}
				blankOrEmptyKeys+=key;
			}
		}
		return blankOrEmptyKeys;
		
	}
	
	/**
	 * @Description: 检测字符串是否以某个表达式开头，
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年10月30日 下午4:36:29 
	 * @param str
	 * @param orPrefixs  多个表达式
	 * @return
	 */
	public static boolean startWithOrPrefixs(String str,Integer toffset, String ...orPrefixs) {
		if(orPrefixs==null||orPrefixs.length==0) {
			return false;
		}
		
		if(toffset==null||toffset <0){
			toffset=0;
		}
		
		for(String orPrefix:orPrefixs){
			if(str.startsWith(orPrefix, toffset)){
				return true;
			}
		}
		return false;
		
	}
	
	/**
	 * @Description: 检测字符串是否以某个表达式开头，
	 * @author: Li Bangming;qq:1715592561     
	 * @date: 2019年10月30日 下午4:36:29 
	 * @param str
	 * @param orPrefixs  多个表达式
	 * @return
	 */
	public static boolean startWithOrPrefixs(String str, String ...orPrefixs) {
		return startWithOrPrefixs(str, null, orPrefixs);
		
	}
	
	public static boolean isNotEmpty(String value) {
		if ((value != null) && (!"".equals(value))) {
			return true;
		}
		return false;
	}

	public static boolean isEmpty(String value) {
		if ((value == null) || ("".equals(value))) {
			return true;
		}
		return false;
	}

	public static boolean equals(String str1, String str2) {
		if (str1.equals(str2)) {
			return true;
		} else {
			return false;
		}
	}

	public static String getFirstStr(String str) {
		return str.substring(0, 1);
	}
	/**
	* @Description:  获取参数为空的key
	* @author: Li Bangming;qq:1715592561     
	* @param keys
	* @param values
	* @return    
	* String    返回类型
	* @throws
	 */
	public static String getBlankOrEmptyKeys(String []keys,Object [] values) {
		if(keys==null||keys.length==0) {
			return null;
		}
		String blankOrEmptyKeys="";
		for(int i=0;i<keys.length;i++) {
			if(!isBlankOrEmpty(blankOrEmptyKeys)) {
				blankOrEmptyKeys+=",";
			}
			if(values!=null&&values.length>i&&!StringUtil.isBlankOrEmpty(values[i].toString())) {
				continue;
			}
			blankOrEmptyKeys+=keys[i];
		}
		return blankOrEmptyKeys;
	}
	
	public static void main(String[] args) {
//		System.out.println(isNumeric(null));
//		 String str = "８１４乡道阿斯蒂芬１２３／．１２，４１２看２家１快２看了就２；看了２叫看来＋看来家１２考虑就２３；了３接口２了２会２，．水电费苦辣时间的２　　１２５１２３１２３１２１２０９－０２１～！＠＃＄％＾＆＊（）＿";
		 //全角转半角
//		 String result =StringUtil.toDbc(str);
//         System.out.println(result);
         //半角转全角
//         System.out.println(StringUtil.toSbc(result));
         
         //去掉空白部分
//         String str1="自动审核不通过,【 2407467342344ed485b7e62935c71d1a,自动审核订单接口】审核订单号5219092723423273845【把车辆信息推送到中台】"
//         		+ "\n共有1条数据有错误 "
//         		+ "\nID:贵JHL679_0,错误字段:engineNum,错误值：陇4S155890,错误信息： engineNum格式不正确" ;
//         System.out.println(str1);
//         System.out.println(replaceBlank(str1));
//         ;
//        String keys= getBlankOrEmptyKeys(new String []{"ss","sss"}, new Object []{1,""});
//        System.out.println(keys);
//		Map<String,Object> map1=new HashMap<String, Object>();
//		Map<String,Object> map2=new HashMap<String, Object>();
//		map1.put("id", null);
//		map2.put("id", "1");
//		map1.put("name", "1");
//		map2.put("name", null);
//		map1.put("sex", "1");
//		map2.put("sex", "1");
//		String neValueKeys=getNeValueKeys(map1, map2, "id","name","sex","dsd");
//		
//		System.out.println(neValueKeys);
		Map<String,Object> map1=new HashMap<String, Object>();
		map1.put("totalMassModify", "saddas");
		map1.put("maintenanceMassModify", "1");
		map1.put("idSs", "1");
		map1.put("ownerNameModify", "1");
		System.out.println("替换前:"+map1);
		Map<String,Object> map2=trimKeysChar(map1, "Modify","Ss");
		System.out.println("替换后:"+map2);
	}
	/**
	* @Description:  检测银行卡号
	* @author: Li Bangming;qq:1715592561     
	* @param bankCard
	* @return    
	* boolean    返回类型
	 */
    public static boolean checkBankCard(String bankCard) {
   	 if(bankCard.length() < 15 || bankCard.length() > 19) {
        //if(bankCard.length() < 15) {
            return false;
        }
        char bit = getBankCardCheckCode(bankCard.substring(0, bankCard.length() - 1));  
        if(bit == 'N'){  
            return false;  
        }  
        return bankCard.charAt(bankCard.length() - 1) == bit;  
   }
    
    private static char getBankCardCheckCode(String bankCard){  
        if(bankCard == null || bankCard.trim().length() == 0  
                || !bankCard.matches("\\d+")) {  
            //如果传的不是数据返回N  
            return 'N';  
        }  
        char[] chs = bankCard.trim().toCharArray();  
        int luhmSum = 0;  
        for(int i = chs.length - 1, j = 0; i >= 0; i--, j++) {  
            int k = chs[i] - '0';  
            if(j % 2 == 0) {  
                k *= 2;  
                k = k / 10 + k % 10;  
            }  
            luhmSum += k;             
        }  
        return (luhmSum % 10 == 0) ? '0' : (char)((10 - luhmSum % 10) + '0');  
    }  
    /**
    * @Description: 获取两个map中值不相同的key
    * @author Li Bangming;qq:1715592561     
    * @date 2020年5月11日 
    * @param map1
    * @param map2
    * @param keys
    * @return String   
    * @throws
     */
    public static String getNeValueKeys(Map<String,Object> map1,Map<String,Object> map2,
    		String ...keys){
    	if(keys==null||keys.length<=0){
    		return null;
    	}
    	String neValueKeys="";
    	for(String key:keys){
    		Object value1=null,value2=null;
    		if(map1!=null){
    			value1=map1.get(key);
    		}
    		if(map2!=null){
    			value2=map2.get(key);
    		}
    		if(value1!=null&&!value1.equals(value2)
    				||value2!=null&&!value2.equals(value1)){
    			if(!isBlankOrEmpty(neValueKeys)){
    				neValueKeys+=",";
    			}
    			neValueKeys+=key;
    		}
    	}
		return neValueKeys;
    	
    }
    
    /**
    * @Description: 去掉map中所有key所包含的字符
    * @author Li Bangming;qq:1715592561     
    * @date 2020年5月11日 
    * @param map
    * @param oldChars
    * @return Map<String,Object>   
    * @throws
     */
    public static Map<String,Object> trimKeysChar(Map<String,Object> map,String... trimChars){
    	if(map==null){
    		return map;
    	}
    	if(trimChars==null||trimChars.length<=0){
    		return map;
    	}
    	Set<String> keys=map.keySet();
    	
    	
    	Map<String,Object> newMap =new HashMap<String,Object>();
    	for(String key:keys){
    		Object value=map.get(key);
    		for(String trimChar:trimChars){
    			key=key.replace(trimChar, "");
    		}
    		newMap.put(key, value);
    	}
    	//清除所有
    	map.clear();
		return newMap;
    	
    }
    
    /**
    * @Description: 去掉map中所有key所包含的字符
    * @author Li Bangming;qq:1715592561     
    * @date 2020年5月11日 
    * @param map
    * @param oldChars
    * @return Map<String,Object>   
    * @throws
     */
    public static Map<String,Object> getKeysChar(Map<String,Object> map,String... trimChars){
    	if(map==null){
    		return map;
    	}
    	if(trimChars==null||trimChars.length<=0){
    		return map;
    	}
    	Set<String> keys=map.keySet();
    	
    	
    	Map<String,Object> newMap =new HashMap<String,Object>();
    	for(String key:keys){
    		Object value=map.get(key);
    		boolean isContain=false;
    		for(String trimChar:trimChars){
    			if(key.contains(trimChar)){
    				isContain=true;
    			}
    		}
    		if(isContain){
	    		newMap.put(key, value);
    		}
    	}
    	//清除所有
    	map.clear();
		return newMap;
    	
    }
	/**
	* @Description: 获取随机自然数
	* @author Li Bangming;qq:1715592561     
	* @date 2020年3月18日 
	* @param len
	* @return String   
	* @throws
	 */
	public static String getRandomNum(int len){
		String randomNum="";
		int i=0;
		while(i<len){
			randomNum+=random.nextInt(10);
			i++;
		}
		return randomNum;
		
	}
	/**
	* @Description: 按照豆号拼接
	* @author Li Bangming;qq:1715592561     
	* @date 2020年7月19日 
	* @param params
	* @return String   
	* @throws
	 */
	public static String commaJoin(String ...params){
		if(params==null||params.length==0){
			return null;
		}
		String commaJoinSti="";
		for(String param: params){
			if(commaJoinSti!=""){
				commaJoinSti+=",";
			}
			commaJoinSti+=param;
		}
		return commaJoinSti;
		
	}
	
	/**
	* @Description: 拼接字符串
	* @author Li Bangming;qq:1715592561     
	* @date 2020年7月19日 
	* @param params
	* @return String   
	* @throws
	 */
	public static String join(String ...params){
		if(params==null||params.length==0){
			return null;
		}
		String joinSti="";
		for(String param: params){
			joinSti+=param;
		}
		return joinSti;
		
	}
	/**
	* @Description: 判断字符是否是中文
	* @author Li Bangming;qq:1715592561     
	* @date 2021年4月21日 
	* @param c
	* @return boolean   
	* @throws
	 */
	private static boolean isChinese(char c) {
	    Character.UnicodeBlock ub = Character.UnicodeBlock.of(c);
	    return ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS
	            || ub == Character.UnicodeBlock.CJK_COMPATIBILITY_IDEOGRAPHS
	            || ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A
	            || ub == Character.UnicodeBlock.GENERAL_PUNCTUATION
	            || ub == Character.UnicodeBlock.CJK_SYMBOLS_AND_PUNCTUATION
	            || ub == Character.UnicodeBlock.HALFWIDTH_AND_FULLWIDTH_FORMS;
	}
	/**
	* @Description: 是否包含中文
	* @author Li Bangming;qq:1715592561     
	* @date 2021年6月23日 
	* @param s1
	* @return String   
	* @throws
	 */
	public static boolean isContainChinese(String s1) {

		if(isBlankOrEmpty(s1)){
			return false;
		}
        for(int i=0;i<s1.length();i++){
        	char c = s1.charAt(i);
        	
        	if (isChinese(c)){
        		return true;
        	}
        }
        return false;
    }
	
	/**
	* @Description: 将字符串中大写字符前加下划线
	* @author Li Bangming;qq:1715592561     
	* @date 2022年3月29日
	* @param str
	* @return
	 */
	public static String  appendUpperCharUnderline(String str) {

		if(isBlankOrEmpty(str)){
			return str;
		}
		
		StringBuffer sb=new StringBuffer();
        for(int i=0;i<str.length();i++){
        	char c = str.charAt(i);
        	
        	if( i > 0 && Character.isUpperCase(c) ){
        		sb.append("_"+c);
        	}else{
        		sb.append(c);

        	}
        }
        return sb.toString();
    }
	
}
