package com.qtzl.sample.web;

import cn.com.taiji.common.model.file.BinServiceResult;
import cn.com.taiji.common.model.file.FileProtocolSystemError;
import com.txffp.api.core.manager.comm.JsonCommManager;
import com.zgglyun.common.manager.net.http.handler.JsonServiceListener;
import com.zgglyun.common.model.json.JsonRequest;
import com.zgglyun.common.model.json.JsonResponse;
import com.zgglyun.common.model.json.JsonServiceEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;


@RestController
public class JsonApiController  {

	protected JsonServiceListener listener;

	@Autowired
	private JsonCommManager jsonCommManager;

	@RequestMapping(value = "/sample/api/json",
			consumes = {MediaType.APPLICATION_JSON_UTF8_VALUE},
			produces = {MediaType.APPLICATION_JSON_UTF8_VALUE},
			method = RequestMethod.POST)
	public String jsonApi(@RequestBody JsonRequest jsonRequest,HttpServletRequest request) {
		long begin = System.currentTimeMillis();
		JsonResponse rs = jsonRequest == null ? new JsonResponse(FileProtocolSystemError.REQ_EMPTY)
				:jsonCommManager.handle(jsonRequest, request);
		assert jsonRequest != null;
		JsonServiceEvent event = JsonServiceEvent.newInstance(jsonRequest, rs, request, 0);
		if (JsonResponse.SUCCESS_CODE == rs.getStatusCode())
		   sendEvent(event, BinServiceResult.SUCCESS, begin);
	    else
	    {
		   event.setErrorMsg(rs.getErrorMsg());
		   sendEvent(event, BinServiceResult.HANDLE_FAILED, begin);
	    }
		return rs.toJson();
	}


	protected void sendEvent(JsonServiceEvent event, BinServiceResult result, long begin)
	{
		if (listener == null) return;
		event.setResult(result).setExecTimeMs(System.currentTimeMillis() - begin);
		listener.onServiceFinished(event);
	}

	protected void setListener(JsonServiceListener listener)
	{
		this.listener = listener;
	}



}
